Mike Gerwitz

Activist for User Freedom

aboutsummaryrefslogtreecommitdiffstats
diff options
context:
space:
mode:
authorMike Gerwitz <mike@mikegerwitz.com>2014-06-17 23:48:13 -0400
committerMike Gerwitz <mike@mikegerwitz.com>2014-06-17 23:54:28 -0400
commit7573a827a0993fbb795c3351140eb5427ac5692a (patch)
tree5bb6670a9c6cb548782318858bf16c72c2dfd21d /test/coreutils/test-cat-until.sh
parent77d4c14e5e1aef1adb7979e00f150c0914032b5b (diff)
downloadpkgsh-7573a827a0993fbb795c3351140eb5427ac5692a.tar.gz
pkgsh-7573a827a0993fbb795c3351140eb5427ac5692a.tar.bz2
pkgsh-7573a827a0993fbb795c3351140eb5427ac5692a.zip
Initial implementation of cat and friendscat
This is intended to be a very basic subset (for now) of cat that will be more efficient for general I/O (mainly pipeines between shell functions) than spawning a process. Benchmarks do show that it is definitely not always worth the trade off, but those situations are less likely to occur (large inputs) and, if they do, the author can be aware of it and use a function that will prevent the builtin from being used (I'll provide that as well, instead of `command cat`). I'll be writing an article on this with benchmarks to rationalize and explain in depth my approach.
Diffstat (limited to 'test/coreutils/test-cat-until.sh')
-rw-r--r--test/coreutils/test-cat-until.sh92
1 files changed, 92 insertions, 0 deletions
diff --git a/test/coreutils/test-cat-until.sh b/test/coreutils/test-cat-until.sh
new file mode 100644
index 0000000..c1ce282
--- /dev/null
+++ b/test/coreutils/test-cat-until.sh
@@ -0,0 +1,92 @@
+#!/bin/bash
+# Tests cat-until{,-incl}
+#
+# Copyright (C) 2014 Mike Gerwitz
+#
+# This file is part of pkgsh.
+#
+# pkgsh is free software: you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation, either version 3 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program. If not, see <http://www.gnu.org/licenses/>.
+##
+
+source src/coreutils/cat.sh
+
+
+test-cat-until-no-delim()
+{
+ local result
+ result="$( cat-until X <<< fooXbar )" \
+ || assert -z "non-zero exit"
+
+ assert "$result" == foo
+}
+
+
+test-cat-until-incl-has-delim()
+{
+ local result
+ result="$( cat-until-incl X <<< fooXbar )" \
+ || assert -z "non-zero exit"
+
+ assert "$result" == fooX
+}
+
+
+test-cat-until-from-file()
+{
+ local result
+ result="$( cat-until X <( echo fooXbar ) )" \
+ || assert -z "non-zero exit"
+
+ assert "$result" == foo
+}
+
+
+test-cat-until-incl-from-file()
+{
+ local result
+ result="$( cat-until-incl X <( echo fooXbar ) )" \
+ || assert -z "non-zero exit"
+
+ assert "$result" == fooX
+}
+
+
+test-cat-until-echoes-all-on-no-delim()
+{
+ local result
+ result="$( cat-until X <<< "foobar" )" \
+ && assert -z "returned successfully on missing delim"
+
+ assert $? -eq 1
+ assert "$result" == foobar
+}
+
+
+test-cat-until-incl-echoes-all-on-no-delim-without-trailing-delim()
+{
+ local result
+ result="$( cat-until-incl X <<< "foobar" )" \
+ && assert -z "returned successfully on missing delim"
+
+ assert "$result" == foobar
+}
+
+
+test-cat-until-no-delim
+test-cat-until-incl-has-delim
+test-cat-until-from-file
+test-cat-until-incl-from-file
+test-cat-until-echoes-all-on-no-delim
+test-cat-until-incl-echoes-all-on-no-delim-without-trailing-delim
+